<?php

	/*
	 * Erweitertes Modul für multiple Varianten komplett neu erfordert Version 2.0 und ersetzt das klassische Variantenmodul
	 * 
	 * Die Varianten sind serialisiert in der Spalte `variantenplus` in der Produkttabelle gespeichert
	 * 
	 * Im Warenkorb ($_SESSION['wpshopgermany']['basket']) sind sie folgendermaßen gespeichert:
	 * 
	 * Array
		(
		    [1] => Array
		        (
		            [produkt_id] => 1
		            [vari] => Array
		                (
		                    [0_0:1_0:2_1] => Array			// Das ist der Schlüssel Variante1:Auswahl1 : Variante2:Auswahl1 usw.
		                        (
		                            [v_id] => 1/0_0:1_0:2_1	// Wie der Schlüssel mit vorangestellter ProduktID
		                            [menge] => 1
		                            [referer] => http://wp.home/
		                        )
		
		                )
		
		        )
		
		)
	 * 
	 * Wird eine Bestellung einer Variante getätigt, so wird in tbl_op in Spalte `mod_vp_varkey` der Wert aus v_id eingetragen
	 * Die Spalte v_id wird -1 und zeigt so die Verwendung des Moduls mod_variantenplus an
	 * 
	 */
	class mod_variantenplus extends mod_basic
	{
		
		var $id = 98;
		var $name = "Varianten";
		var $desc = 'Erlaubt die Definition von mehreren Produktvarianten.';
		var $hilfeURL = "http://wpshopgermany.maennchen1.de/?p=1057";
		var $group = 'Produkte';
		 		
		public function __construct($controller)
		{
			
			$this->controller = $controller;
						
			unset($this->controller->mods['mod_varianten']);
			unset($this->controller->allmods['mod_varianten']);
			
		} // public function __construct($controller)
		
		public function install()
		{

			// Alle Produkte die alte Varianten haben
			$pOldVari = $this->controller->db->fetchAssocField("
				SELECT
					DISTINCT V.`p_id`
				FROM
					`".$this->controller->tbl_vr."` AS V
			"); 
			
			foreach ($pOldVari as $p_id)
			{
				
				$arVari = $this->controller->db->fetchAssoc("
					SELECT
						V.*
					FROM
						`".$this->controller->tbl_vr."` AS V
					WHERE
						V.`p_id` = '".wpsg_q($p_id)."' AND
						V.`deleted` != '1'
					ORDER BY 
						V.`id` ASC
				");
				
				$arVariationen = array();
				$lang = array();
				
				foreach ($arVari as $v)
				{
										
					$arVariINS = array(
						"name" => $v['name'],
						"preis" => $v['preis'],
						"aktiv" => "1",
						"stock" => $v['stock'],
						"weight" => $v['weight']
					);
					
					$locale = unserialize($v['locale']);
					if (is_array($locale))
					{
						 
						//$variantenplus[$k]['vari'][$vari_id]['name'] = $vari_lang['name'];
						//foreach ($v['lang'][get_locale()]['vari'] as $vari_id => $vari_lang)
						
						foreach ($locale as $l_key => $l)
						{
							
							$lang[$l_key]['vari'][sizeof($arVariationen)]['name'] = $l['name'];
							
						}
						
					}
					
					$arVariationen[] = $arVariINS;
					
				}
				
				$arVar = array(
					"name" => "Variante",
					"typ" => "radio",
					"aktiv" => "1",
					"vari" => $arVariationen 
				);
				
				if (is_array($lang)) $arVar['lang'] = $lang;
				
				$arVP = array($arVar);
				
				// Prüfen das in dem Produkt nicht schon neue Varianten im Variantenplus format gespeichert wurden
				// Sollte das aus irgendeinem Grund der Fall sein, so mache hier gar nichts mehr damit nichts verloren geht
				$strVP = $this->controller->db->fetchOne("SELECT P.`variantenplus` FROM `".$this->controller->tbl_vr."` AS P WHERE `id` = '".wpsg_q($p_id)."'");
				
				if (trim($strVP) == '')
				{ 
					
					// Neue Varianteneinstellungen speichern
					$this->controller->db->UpdateQuery($this->controller->tbl_pr, array(
						"variantenplus" => serialize($arVP)
					), "`id` = '".wpsg_q($p_id)."'");
										
					// Alte Varianten löschen
					$this->controller->db->Query("DELETE FROM `".$this->controller->tbl_vr."` WHERE `p_id` = '".wpsg_q($p_id)."'");

				}
					
			}
			
		}
		
		public function init()
		{
			
			wp_enqueue_script('wpsg_vp', WP_PLUGIN_URL.'/wpshopgermany/views/mods/mod_variantenplus/variantenplus.js');
			
		}
		
		public function Produkt_add() 
		{ 
			
			if ($_REQUEST['edit_id'] <= 0) return;
			
			if ($this->controller->data['typ'] == "produktpaket")
			{
				return;
			}
			
			return $this->controller->loadTemplate(dirname(__FILE__)."/../views/mods/mod_variantenplus/addedit.phtml");			
			
		} // public function Produkt_add()
		 		
		public function Warenkorb_addForm(&$data)
		{
			
			$variantenplus = unserialize($this->controller->db->fetchOne("SELECT `variantenplus` FROM `".$this->controller->tbl_pr."` WHERE `id` = '".wpsg_q($data['p_id'])."'"));
			
			if (is_array($variantenplus) && sizeof($variantenplus) > 0)
			{
				
				// Mögliche Übersetzung laden
				if ($this->controller->isOtherLang())
				{
					
					foreach ($variantenplus as $k => $v)
					{
						
						if (is_array($v['lang'][get_locale()]))
						{
							
							if (isset($v['lang'][get_locale()]['name']))
							{
								$variantenplus[$k]['name'] = $v['lang'][get_locale()]['name'];
							}
							
							if (is_array($v['lang'][get_locale()]['vari']))
							{
							
								foreach ($v['lang'][get_locale()]['vari'] as $vari_id => $vari_lang)
								{
									
									$variantenplus[$k]['vari'][$vari_id]['name'] = $vari_lang['name'];
									
								}
								
							}
							
						}
						
					} 
									
				}
				 
				$data['variantenplus'] = $variantenplus;
				
			}
						
		} // public function Warenkorb_addForm(&$data)
		
		public function settings_edit()
		{

			if (get_option("mod_variantenplus") != "1") return;
			
			$content .= '<tr><td>'.__("Version", "wpsg").': </td><td><b>'.$this->version.'</b></td></tr>';
						
			//if ($_REQUEST['modul_aktiv'] === '0' || (!array_key_exists("mod_variantenplus", $this->controller->mods) && $_REQUEST['modul_aktiv'] != '1')) return false;
			
			return $content.$this->controller->loadTemplate(dirname(__FILE__)."/../views/mods/mod_variantenplus/settings_edit.phtml");
			
		} // public function settings_edit()
		
		public function settings_save()
		{
			
			update_option("wpsg_vp_showpic_height", $_REQUEST['wpsg_vp_showpic_height']);
			update_option("wpsg_vp_showpic_width", $_REQUEST['wpsg_vp_showpic_width']);
			update_option("wpsg_vp_showpic", $_REQUEST['wpsg_vp_showpic']);
			
		} // public function settings_save()
		
		/**
		 * Behandelt die Frontend Ajax Anfragen
		 */
		public function FE_ajax_action()
		{
			 
			$produkt_id = preg_replace("/\/(.*)/", "", $_REQUEST['var_key']);
			$var_key = preg_replace("/^\d*\//", "", $_REQUEST['var_key']);
						
			$arVar = array();
			$var1 = explode(":", $var_key);
			
			foreach ($var1 as $v)
			{
				$var2 = explode("_", $v);
				$arVar[$var2[0]] = $var2[1];
			}
			
			$vp_data = $this->loadVarianten($produkt_id);
			
			//$handle = opendir(WP_CONTENT_DIR.'/uploads/produktbilder/'.$produkt_id."/");
			$handle = opendir($this->controller->mods['mod_produktbilder']->getPicPath($produkt_id));
			
			// Bilder des Produktes laden
			$arBilder = array(); $i = 1;
   			while($filename = readdir($handle))
   			{
   				 
   				//$file = WP_CONTENT_DIR.'/uploads/produktbilder/'.$produkt_id."/".$filename;
   				$file = $this->controller->mods['mod_produktbilder']->getPicPath($produkt_id).'/'.$filename;
   				if (is_file($file) && $file != "." && $file != "..")
   				{
   					
   					$arBilder[] = $filename; $i ++;
   					
   				}
   				   				   				   				   				
   			}  
			 
   			foreach ($arBilder as $bild)
   			{
   				
   				$filename = preg_replace("/\.([^\.]*)/", "", $bild);
   				
				if ($filename == "vp_".str_replace(":", "-", $var_key)) die($bild);
   				
   			}
   			
			foreach ($vp_data as $var_key => $var)
			{
				
				if (array_key_exists($var_key, $arVar))
				{
					
					if ($var['typ'] == "checkbox")
					{
						
						if ($arVar[$var_key] == "1")
						{
							$arBilder = array_intersect($arBilder, explode(",", $var['pic']));
						}
						else 
						{
							$arBilder = array_diff($arBilder, explode(",", $var['pic']));
						}
						
					}
					else 
					{
						
						$arBilder = array_intersect($arBilder, explode(",", $var['vari'][$arVar[$var_key]]['pic']));
						
					}
					
				}
				
			}
			
			$arBilder = $this->checkPics($arBilder, $produkt_id);
			
			if (sizeof($arBilder) <= 0) echo "-1";
			else
			{
				echo $arBilder[array_rand($arBilder)];	
			}				
			
		} // public function FE_ajax_action()
				
		public function Produkt_ajax() {
			
			if ($_REQUEST['command'] == "wpsg_vp_add")
			{
				 
				$vp_data = $this->loadVarianten($_REQUEST['edit_id']);
				
				$data = array(
					"name" => $_REQUEST['name'],
					"typ" => $_REQUEST['typ'],
					"aktiv" => "1"
				);
				
				if ($_REQUEST['typ'] == "checkbox")
				{
					$data['preis'] = "0";
				}
				else
				{
					$data['vari'] = array();
				}
				
				$vp_data[] = $data;

				$this->saveVarianten($_REQUEST['edit_id'], $vp_data);
				
				$this->controller->data['message'] = array(0, __("Variante erfolgreich angelegt.", "wpsg"));
				die($this->drawVarianten($_REQUEST['edit_id']));
				
			}
			else if ($_REQUEST['command'] == "wpsg_vp_del")
			{
				
				$vp_data = $this->loadVarianten($_REQUEST['edit_id']);
				
				unset($vp_data[$_REQUEST['var_id']]);
				
				$this->saveVarianten($_REQUEST['edit_id'], $vp_data);
				
				$this->controller->data['message'] = array(0, __("Variante wurde erfolgreich gelöscht.", "wpsg"));				
				die($this->drawVarianten($_REQUEST['edit_id']));
				
			}
			else if ($_REQUEST['command'] == "wpsg_vp_deaktiv")
			{
 	
				$vp_data = $this->loadVarianten($_REQUEST['edit_id']);
				
				if ($_REQUEST['status'] == "1")
				{
					
					$vp_data[$_REQUEST['var_id']]['aktiv'] = 1;
					$this->controller->data['message'] = array(0, __("Variante wurde erfolgreich aktiviert.", "wpsg"));
						
				}
				else
				{
					
					$vp_data[$_REQUEST['var_id']]['aktiv'] = 0;
					$this->controller->data['message'] = array(0, __("Variante wurde erfolgreich deaktiviert.", "wpsg"));
					
				}
				
				$this->saveVarianten($_REQUEST['edit_id'], $vp_data);
				die($this->drawVarianten($_REQUEST['edit_id']));				
				
			}
			else if ($_REQUEST['command'] == "wpsg_vp_addVariation")
			{
				
				$vp_data = $this->loadVarianten($_REQUEST['edit_id']);
				
				$vp_data[$_REQUEST['var_id']]['vari'][] = array(
					"name" => $_REQUEST['vari_name'],
					"preis" => $this->controller->getNumberValue($_REQUEST['vari_preis']),
					"aktiv" => "1"
				);
				
				$this->controller->data['message'] = array(0, __("Variation wurde erfolgreich angelegt.", "wpsg"));
				
				$this->saveVarianten($_REQUEST['edit_id'], $vp_data);
				die($this->drawVarianten($_REQUEST['edit_id']));
				
			}
			else if ($_REQUEST['command'] == "wpsg_vp_vari_del")
			{
				
				$vp_data = $this->loadVarianten($_REQUEST['edit_id']);
				
				unset($vp_data[$_REQUEST['var_id']]['vari'][$_REQUEST['vari_id']]);				
				
				$this->controller->data['message'] = array(0, __("Variation wurde erfolgreich gelöscht.", "wpsg"));
				
				$this->saveVarianten($_REQUEST['edit_id'], $vp_data);
				die($this->drawVarianten($_REQUEST['edit_id']));
				
			}
			else if ($_REQUEST['command'] == "wpsg_vp_vari_deaktiv")
			{
				
				$vp_data = $this->loadVarianten($_REQUEST['edit_id']);
				
				if ($_REQUEST['status'] == "1")
				{
					
					$vp_data[$_REQUEST['var_id']]['vari'][$_REQUEST['vari_id']]['aktiv'] = 1;
					$this->controller->data['message'] = array(0, __("Variation wurde erfolgreich aktiviert.", "wpsg"));
						
				}
				else
				{
					
					$vp_data[$_REQUEST['var_id']]['vari'][$_REQUEST['vari_id']]['aktiv'] = 0;
					$this->controller->data['message'] = array(0, __("Variation wurde erfolgreich deaktiviert.", "wpsg"));
					
				}
				
				$this->saveVarianten($_REQUEST['edit_id'], $vp_data);
				die($this->drawVarianten($_REQUEST['edit_id']));
				
			}
			else if ($_REQUEST['command'] == "wpsg_vp_vari_setPic")
			{
				
				$vp_data = $this->loadVarianten($_REQUEST['edit_id']);
				
				if ($_REQUEST['vari_id'] >= 0)
				{
					
					$arPic = explode(",", $vp_data[$_REQUEST['var_id']]['vari'][$_REQUEST['vari_id']]['pic']);
					wpsg_debug($arPic);
					if (in_array($_REQUEST['pic'], $arPic))
					{
						unset($arPic[array_search($_REQUEST['pic'], $arPic)]);
					}
					else
					{
						$arPic[] = $_REQUEST['pic'];
					}
					
					$vp_data[$_REQUEST['var_id']]['vari'][$_REQUEST['vari_id']]['pic'] = implode(",", $arPic);
					
				}
				else
				{
					
					$arPic = explode(",", $vp_data[$_REQUEST['var_id']]['pic']);
					
					if (in_array($_REQUEST['pic'], $arPic))
					{
						unset($arPic[array_search($_REQUEST['pic'], $arPic)]);
					}
					else
					{
						$arPic[] = $_REQUEST['pic'];
					}
					
					$vp_data[$_REQUEST['var_id']]['pic'] = implode(",", $arPic);
						
				}
				
				$this->saveVarianten($_REQUEST['edit_id'], $vp_data);
				
				die("1");
				
			}
			else if ($_REQUEST['command'] == "wpsg_vp_vari_inlineEdit")
			{
				
				$vp_data = $this->loadVarianten($_REQUEST['edit_id']);
				
				if ($_REQUEST['typ'] == "vari_name") 
				{
					
					if (isset($_REQUEST['wpsg_lang']))
					{
						$vp_data[$_REQUEST['var_id']]['lang'][$_REQUEST['wpsg_lang']]['vari'][$_REQUEST['vari_id']]['name'] = $_REQUEST['q'];	
					}
					else
					{					
						$vp_data[$_REQUEST['var_id']]['vari'][$_REQUEST['vari_id']]['name'] = $_REQUEST['q'];
					}
					
				}
				else if ($_REQUEST['typ'] == "vari_preis")
				{
					
					$_REQUEST['q'] = $this->controller->getNumberValue($_REQUEST['q']);
					$vp_data[$_REQUEST['var_id']]['vari'][$_REQUEST['vari_id']]['preis'] = $_REQUEST['q'];
					
				}
				else if ($_REQUEST['typ'] == "vari_weight")
				{
					
					$_REQUEST['q'] = $this->controller->getNumberValue($_REQUEST['q']);
					$vp_data[$_REQUEST['var_id']]['vari'][$_REQUEST['vari_id']]['weight'] = $_REQUEST['q'];
										
				}
				else if ($_REQUEST['typ'] == "vari_stock")
				{
				
					$_REQUEST['q'] = $this->controller->getNumberValue($_REQUEST['q']);
					$vp_data[$_REQUEST['var_id']]['vari'][$_REQUEST['vari_id']]['stock'] = $_REQUEST['q'];
					
				}
				else if ($_REQUEST['typ'] == "var_name")
				{
					
					if (isset($_REQUEST['wpsg_lang']))
					{
						$vp_data[$_REQUEST['var_id']]['lang'][$_REQUEST['wpsg_lang']]['name'] = $_REQUEST['q'];	
					}
					else
					{
						$vp_data[$_REQUEST['var_id']]['name'] = $_REQUEST['q'];
					}
						
				}
				else if ($_REQUEST['typ'] == "var_preis")
				{
					
					$_REQUEST['q'] = $this->controller->getNumberValue($_REQUEST['q']);
					$vp_data[$_REQUEST['var_id']]['preis'] = $_REQUEST['q'];
					
				}
				else if ($_REQUEST['typ'] == "var_weight")
				{
					
					$_REQUEST['q'] = $this->controller->getNumberValue($_REQUEST['q']);
					$vp_data[$_REQUEST['var_id']]['weight'] = $_REQUEST['q'];
					
				}
				else if ($_REQUEST['typ'] == "var_stock")
				{
					
					$_REQUEST['q'] = $this->controller->getNumberValue($_REQUEST['q']);
					$vp_data[$_REQUEST['var_id']]['stock'] = $_REQUEST['q'];
					
				}
				
				$this->saveVarianten($_REQUEST['edit_id'], $vp_data);
				
				die($_REQUEST['q']);
				
			}
			
		}
		
		public function Produkt_save(&$data) 
		{ 
			
			//$vp_data = $this->loadVarianten($_REQUEST['edit_id']);
			//wpsg_debug($vp_data);
			//Hier später mal vieleicht säubern und schauen ob die Bilder noch existieren
			
		}
		
		public function Warenkorb_update() 
		{ 

			if (isset($_REQUEST['wpsg_vp']))
			{
				
				$var_key2 = array();
				$var_key2[] = $_REQUEST['produkt'];
				
				foreach ($_REQUEST['wpsg_vp'] as $k => $v) { $var_key[] = $k."_".$v; $var_key2[] = $k.'_'.$v; }
				$var_key = implode(":", $var_key);
				
				$bFound = false;
				
				// Warenkorb durchgehen und entsprechende Variante aktualisieren
				foreach ((array)$_SESSION['wpshopgermany']['basket'][$_REQUEST['produkt']]['vari'] as $k => $v)
				{
					
					if ($k == $var_key)
					{
						
						if (array_key_exists("mod_stock", $this->controller->mods))
						{
							
							$var_conf = unserialize($this->controller->db->fetchOne("SELECT P.`variantenplus` FROM `".$this->controller->tbl_pr."` AS P WHERE P.`id` = '".wpsg_q($_REQUEST['produkt'])."'"));
							
							$arVari = explode(":", $var_key);
							$arStock = array();
							
							foreach ($arVari as $var_vari)
							{
								
								$varianten_id = str_replace("/\:\d*/", "", $var_vari);
								$variation_id = str_replace("/\d*\:/", "", $var_vari);

								if (isset($var_conf[$varianten_id]['vari'][$variation_id]['stock']))
									$arStock[] = $var_conf[$varianten_id]['vari'][$variation_id]['stock'];
								
							}
							
							if ($_REQUEST['menge'] > min($arStock) && sizeof($arStock) > 0)
							{
								
								$_SESSION['wpshopgermany']['meldungen'][] = array(0, _("Menge wurde korrigiert, da die Bestellmenge den Lagerbestand übersteigt."));
								$_REQUEST['menge'] = min($arStock);
								
							}
													
						}
 
						$_SESSION['wpshopgermany']['basket'][$_REQUEST['produkt']]['vari'][$var_key]['menge'] += intval($_REQUEST['menge']);
						$_SESSION['wpshopgermany']['basket'][$_REQUEST['produkt']]['vari'][$var_key]['referer'] = $_SERVER['HTTP_REFERER'];
						$bFound = true;		
						$this->controller->do = "refresh";			
							
					}
					
				}
				
				if ($bFound == false)
				{
					
					if (!is_array($_SESSION['wpshopgermany']['basket'][$_REQUEST['produkt']]['vari']))
						$_SESSION['wpshopgermany']['basket'][$_REQUEST['produkt']]['vari'] = array();
						
					$_SESSION['wpshopgermany']['basket'][$_REQUEST['produkt']]['vari'][$var_key] = array(
						"v_id" => $_REQUEST['produkt']."/".$var_key,
						"menge" => intval($_REQUEST['menge']),
						"referer" => $_SERVER['HTTP_REFERER']
					);
					
					if (isset($_REQUEST['special_preis']))
					{
						
						$rabattPreis = $_SESSION['wpsg_special_preis'][$var_key2[0]];
						
						for ($i = 1; $i < sizeof($var_key2); $i ++)
						{
							$rabattPreis += $_SESSION['wpsg_special_preis'][$var_key2[0].'_'.$var_key2[$i]];
						}
	 
						if ($_REQUEST['special_preis'][$_REQUEST['produkt']] == $rabattPreis)
						{						
							$_SESSION['wpshopgermany']['basket'][intval($_REQUEST['produkt'])]['vari'][$var_key]['preis'] = $rabattPreis;	
						}
						
					}
					
					$this->controller->do = "insert";
					
				}
				 
				if (array_key_exists('mod_produktvars', $this->controller->mods))
				{
					
					$this->controller->mods['mod_produktvars']->Warenkorb_add();
					
				}
				
				$this->controller->updateDone = true;
				
			} 
			 
		} // public function Warenkorb_update() 
		
		public function Warenkorb_add() 
		{
			
			if (isset($_REQUEST['wpsg_vp']))
			{
				
				/* Ist der Key der im Rabatt Modul für den Specialpreis verwendet wird */
				$var_key2 = array();
				$var_key2[] = $_REQUEST['produkt'];
				
				$var_conf = unserialize($this->controller->db->fetchOne("SELECT P.`variantenplus` FROM `".$this->controller->tbl_pr."` AS P WHERE P.`id` = '".wpsg_q($_REQUEST['produkt'])."'"));
								
				if (array_key_exists("mod_stock", $this->controller->mods)) $arStock = array();
				foreach ($_REQUEST['wpsg_vp'] as $k => $v) 
				{ 
					
					$var_key[] = $k."_".$v; $var_key2[] = $k.'_'.$v;
					
					if (isset($var_conf[$k]['vari'][$v]['stock']) && array_key_exists("mod_stock", $this->controller->mods)) 
						$arStock[] = $var_conf[$k]['vari'][$v]['stock']; 
				
				}
				
				if (array_key_exists("mod_stock", $this->controller->mods) && $_REQUEST['menge'] > min($arStock) && sizeof($arStock) > 0) 
				{
					
					$_SESSION['wpshopgermany']['meldungen'][] = array(0, _("Menge wurde korrigiert, da die Bestellmenge den Lagerbestand übersteigt."));
					$_REQUEST['menge'] = min($arStock);
					
				}
				
				$var_key = implode(":", $var_key);
				
				$_SESSION['wpshopgermany']['basket'][intval($_REQUEST['produkt'])] = array(
					"produkt_id" => intval($_REQUEST['produkt'])
				);
				
				$_SESSION['wpshopgermany']['basket'][intval($_REQUEST['produkt'])]['vari'] = array();

				$_SESSION['wpshopgermany']['basket'][intval($_REQUEST['produkt'])]['vari'][$var_key] = array(
					"v_id" => $_REQUEST['produkt']."/".$var_key,
					"menge" => intval($_REQUEST['menge']),
					"referer" => $_SERVER['HTTP_REFERER']
				);
				 
				if (isset($_REQUEST['special_preis']))
				{
					
					$rabattPreis = $_SESSION['wpsg_special_preis'][$var_key2[0]];
					
					for ($i = 1; $i < sizeof($var_key2); $i ++)
					{
						$rabattPreis += $_SESSION['wpsg_special_preis'][$var_key2[0].'_'.$var_key2[$i]];
					}
 
					if ($_REQUEST['special_preis'][$_REQUEST['produkt']] == $rabattPreis)
					{						
						$_SESSION['wpshopgermany']['basket'][intval($_REQUEST['produkt'])]['vari'][$var_key]['preis'] = $rabattPreis;	
					}
					
				}
				
				if (array_key_exists('mod_produktvars', $this->controller->mods))
				{
					
					$this->controller->mods['mod_produktvars']->Warenkorb_add();
					
				}
				
				$this->controller->addDone = true;
				
			}
			
		} // public function Warenkorb_add()
		
		public function Warenkorb_calculateBasket(&$data) { 
			
			if (!is_array($data['vari'])) return;
			
			$vp_data = $this->loadVarianten($data['produkt_id']);
			 
			foreach ($data['vari'] as $vp => $v)
			{
							
				$arV = explode(":", $vp);

				$preis = $data['preis'];
				foreach ($arV as $k => $v2)
				{
					
					$vari_set = explode("_", $v2);
					
					if ($vp_data[$vari_set[0]]['typ'] == "checkbox")
					{
						if ($vari_set[1] == "1")
						{
							
							$preis += $vp_data[$vari_set[0]]['preis'];
							
						}	
					}
					else
					{
						
						$preis += $vp_data[$vari_set[0]]['vari'][$vari_set[1]]['preis'];

					}
					
				}
				
				if ($this->controller->noMwSt)
				{
						
					$neg = $preis - ($preis / (1 + ($this->controller->arMwStDB[$data['mwst']]['value'] / 100)));					
					$preis = $preis / (1 + ($this->controller->arMwStDB[$data['mwst']]['value'] / 100));
					$this->controller->sumValues['produktpreis'] -= $neg;
							 	
				}
 	
				$this->controller->sum += $v['menge'] * $preis;
				
			}
 
			$this->controller->calcDone = true;
			
		} // public function Warenkorb_calculateBasket()
		
		public function Warenkorb_prepareBasketRendering() { 
			
			$basket_neu = array();
			
			if (is_array($this->controller->basket) && sizeof($this->controller->basket) > 0)
			{
				
				foreach ($this->controller->basket as $p_id => $p_data)			
				{
					
					if (!is_array($p_data['vari']))
					{
						
						// Kein Variantenprodukt normal hinzufügen
						$basket_neu[$p_id] = $p_data;
						
					}
					else
					{
						
						$vp_data = $this->loadVarianten($p_id);
						
						foreach ($p_data['vari'] as $v_id => $v_data)
						{
 
							$preis = $p_data['preis'];
							
							// vp_date
							$arVarianten = array();
							$vari_set = (array)explode(":", preg_replace("/\d*\//", "", $v_data['v_id']));							
							foreach ($vari_set as $k2 => $v2) { $vari = explode("_", $v2); $arVarianten[$vari[0]] = $vari[1]; }
							 
							foreach ($vp_data as $var_key => $var)
							{
								
								if ($var['typ'] == "checkbox")
								{
									if ($arVarianten[$var_key] == "1") $preis += $var['preis'];
								}
								else
								{
									
									$preis += $var['vari'][$arVarianten[$var_key]]['preis'];
									
								}
								
							}
							
							if ($this->controller->noMwSt)
							{
								
								$neg = $preis - ($preis / (1 + ($this->controller->arMwStDB[$p_data['mwst']]['value'] / 100)));					
								$preis = $preis / (1 + ($this->controller->arMwStDB[$p_data['mwst']]['value'] / 100));
								$this->controller->sumValues['produktpreis'] -= $neg;
																
							}
							
							$basket_neu[] = array(
								"produkt_id" => $p_id,
								"mwst" => $p_data['mwst'],
								"name" => $p_data['name'],
								"preis" => $preis,
								"menge" => $v_data['menge'],
								"referer" => $v_data['referer'],
								"v_id" => $p_id."/".$v_id
							);
														
						}
						
					}
					
				}
				
			}
			
			if (is_array($basket_neu) && sizeof($basket_neu) > 0) $this->controller->basket = $basket_neu;
			 
		} // public function Warenkorb_prepareBasketRendering()
		
		/**
		 * Zeichnet das Tempalte für die Ausgabe in dem Produkttemplates
		 * @param unknown_type $produkt_id
		 */
		public function renderTemplate($produkt_id)
		{
			
			$this->controller->data['produkt'] = $this->controller->db->fetchRow("SELECT * FROM `".$this->controller->tbl_pr."` WHERE `id` = '".wpsg_q($produkt_id)."'");
			
			//$this->controller->data['vp_data'] = $this->loadVarianten($produkt_id);			
			if (!is_array($this->controller->data['variantenplus']) || sizeof($this->controller->data['variantenplus']) < 0) return;
			
			if (array_key_exists("mod_stock", $this->controller->mods))
			{
				
				foreach ($this->controller->data['variantenplus'] as $k => $v)
				{
					
					if ($v['typ'] == "checkbox" && $v['stock'] <= 0)
					{						
						unset($this->controller->data['variantenplus'][$k]);
					}
					else if ($v['typ'] != "checkbox") 
					{
						
						$drin = 0;
						foreach ($v['vari'] as $k2 => $v2)
						{
							
							if ($v2['stock'] > 0) $drin ++;
							else
							{
								unset($this->controller->data['variantenplus'][$k]['vari'][$k2]);
							}
							
						}
						
						if ($drin == 0)
						{
							unset($this->controller->data['variantenplus'][$k]);
						}
						
					}
					
				}
				
			}
			
			if (get_option("wpsg_vp_showpic") == "1") 
			{
				
				foreach ($this->controller->data['variantenplus'] as $k => $v)
				{
					
					if ($v['typ'] == "checkbox")
					{
	
						$arPics = wpsg_explode(",", $v['pic']);
						$arPics = $this->checkPics($arPics, $produkt_id);
						
						$showPic = false;
						if (sizeof($arPics) > 0)
						{
							$showPic = $arPics[array_rand($arPics)]; 
						}
						
						$this->controller->data['variantenplus'][$k]['showpic'] = $showPic;
						 
					}
					else
					{ 
						
						foreach ($v['vari'] as $k2 => $v2)
						{
							
							$arPics = wpsg_explode(",", $v2['pic']);
							$arPics = $this->checkPics($arPics, $produkt_id);
							
							$showPic = false;
							if (sizeof($arPics) > 0)
							{
								$showPic = $arPics[array_rand($arPics)];
							}
							
							$this->controller->data['variantenplus'][$k]['vari'][$k2]['showpic'] = $showPic; 
							
						}
						
					}
					
				}
				
			}
			
			return $this->controller->loadTemplate(dirname(__FILE__)."/../views/mods/mod_variantenplus/produkt.phtml");
			
		} // public function renderTemplate($produkt_id)
		
		public function Warenkorb_remove($p_id, $m) 
		{ 
						
			if (preg_match("/\d*\/\d*/", $_REQUEST['submit_removeprodukt']))
			{
				
				$produkt_id = preg_replace("/\/(.*)/", "", $_REQUEST['submit_removeprodukt']);
				$var_key = preg_replace("/((.*)\/)|(_\d*$)/", "", $_REQUEST['submit_removeprodukt']);
				
				unset($_SESSION['wpshopgermany']['basket'][$produkt_id]['vari'][$var_key]);
				
				if (sizeof($_SESSION['wpshopgermany']['basket'][$produkt_id]['vari']) <= 0)
				{
					unset($_SESSION['wpshopgermany']['basket'][$produkt_id]);
				}
 
				$this->controller->do = "remove";
				$this->controller->removeDone == true;
				
			}
			
		} // public function Warenkorb_remove()
		
		public function Warenkorb_refresh($p_id, $m) 
		{ 
			
			if ($this->controller->refreshDone) return;
			
			if (preg_match("/\d*\//", $p_id))
			{
								
				$produkt_id = preg_replace("/\/(.*)/", "", $p_id);
				
				$p_id = preg_replace("/\_".$produkt_id."$/", "", $p_id);
				
				$var_key = preg_replace("/(.*)\//", "", $p_id);
				
				if ($m <= 0)
				{

					unset($_SESSION['wpshopgermany']['basket'][$produkt_id]['vari'][$var_key]);
					if (sizeof($_SESSION['wpshopgermany']['basket'][$produkt_id]['vari']) == 0)
					{
						unset($_SESSION['wpshopgermany']['basket'][$produkt_id]);						
					}
					$this->controller->do = "remove";
					
				}
				else
				{

					$_SESSION['wpshopgermany']['basket'][$produkt_id]['vari'][$var_key]['menge'] = $m;
					$this->controller->do = "refresh";
					
				}
				
				$this->controller->refreshDone = true;	
				
			} 
			
		} // public function Warenkorb_refresh($p_id, $m)
		
		public function Warenkorb_renderProduktRow($p, $i)
		{
			
			if (!isset($p['v_id']) || $p['v_id'] == "") return;

			$this->data['strVarianten'] = $this->loadVariantenString($p['produkt_id'], $p['v_id']);
			
			include $this->render("/mod_variantenplus/produkt_row_basket.phtml"); 
						
		} // public function Warenkorb_renderProduktRow($p, $i)
		
		public function Warenkorb_renderProduktRow_overview($p, &$i) 
		{ 
			 
			if (!isset($p['v_id']) || $p['v_id'] == "") return;

			$this->data['strVarianten'] = $this->loadVariantenString($p['produkt_id'], $p['v_id']);
			
			include $this->render("/mod_variantenplus/produkt_row_overview.phtml"); 
			
		} // public function Warenkorb_renderProduktRow_overview($p, &$i)
		
		public function Warenkorb_do2(&$data) { 

			if (isset($data['v_id']))
			{
				
				if ($this->controller->noMwSt == true)
				{
					$mwst = 0;
				}
				else
				{
					$mwst = $this->controller->db->fetchOne("SELECT `value` FROM `".$this->controller->tbl_mw."` WHERE `id` = '".wpsg_q($data['mwst'])."'");
				}
								
				$this->controller->db->ImportQuery($this->controller->tbl_op, array(
					"o_id" => wpsg_q($this->controller->order_id),
					"p_id" => wpsg_q($data['produkt_id']),
					"v_id" => "-1",
					"menge" => wpsg_q($data['menge']),
					"price" => wpsg_q($data['preis']),
					"mwst" => wpsg_q($mwst),
					"mod_vp_varkey" => wpsg_q($data['v_id'])
				));	
				
				$this->controller->importDone = true;
				
			}
			
		} // public function Warenkorb_do2()
		
		public function order_produktrow($produkt, $i)
		{
			
			if (!isset($produkt['mod_vp_varkey']) || $produkt['mod_vp_varkey'] == "") return;
			
			$this->data['i'] = $i;			
			$this->data['strVarianten'] = $this->loadVariantenString($produkt['p_id'], $produkt['mod_vp_varkey']);			
			
			include $this->render("/mod_variantenplus/order_row.phtml");			
			
		} // public function order_produktrow($produkt, $i)
		
		/**
		 * Zeichnet den Bereich der Varianten für ein Produkt mit der Produkt ID $produkt_id
		 * @param unknown_type $produkt_id
		 */
		public function drawVarianten($produkt_id)
		{
			
			$pic_dir = $this->controller->mods['mod_produktbilder']->getPicPath($_REQUEST['edit_id']);
			
			$handle = opendir($pic_dir);
			
			// Bilder des Produktes laden
			$arBilder = array(); $i = 1;
   			while($filename = readdir($handle))
   			{
   				 
   				$file = $pic_dir."/".$filename;
   				if (is_file($file) && $file != "." && $file != "..")
   				{
   					
   					$arBilder[] = $filename; $i ++;
   					
   				}
   				   				   				   				   				
   			}  
   			
   			asort($arBilder);

   			$this->controller->data['arBilder'] = array();
   			foreach ($arBilder as $k => $v)
   			{
   				
   				$url_tn = $this->controller->mods['mod_produktbilder']->makeTn($_REQUEST['edit_id'], $v, 25, 25, 's');
   				$this->controller->data['arBilder'][$v] = $url_tn;
   				
   			}
    
			$this->controller->data['vp_data'] = $this->loadVarianten($produkt_id);
									
			return $this->controller->loadTemplate(dirname(__FILE__)."/../views/mods/mod_variantenplus/drawVarianten.phtml");
						
		} // public function drawVarianten($produkt_id)
		
		public function loadVariantenString($produkt_id, $v_id)
		{
			 
			// Eventuelle ProduktID abtrennen			
			$v_id = preg_replace("/^\d*\//", "", $v_id);
			
			$arVari_set = explode(":", preg_replace("/\d*\//", "", $v_id));
			$arVari = array();
			foreach ($arVari_set as $k => $v)
			{
				$arVari_set2 = explode("_", $v);
				$arVari[$arVari_set2[0]] = $arVari_set2[1];
			}
			
			$vp_data = $this->loadVarianten($produkt_id);
			
			$arVarianten = array();
			foreach ($vp_data as $var_key => $var)
			{
				
				if ($var['typ'] == "checkbox" && $arVari[$var_key] == "1")
				{
					$arVarianten[] = $var['name'];
				}
				else if ($var['typ'] != "checkbox")
				{
					$arVarianten[] = $var['vari'][$arVari[$var_key]]['name'];
					
				}
				
			}			
			
			return implode(" / ", $arVarianten);
			
		}
		
		public function saveVarianten($produkt_id, $vp_data)
		{
			  
			$this->controller->db->UpdateQuery($this->controller->tbl_pr, array(
				"variantenplus" => serialize($vp_data)
			), "`id` = '".wpsg_q($produkt_id)."'");
		  
		}
		
		public function loadVarianten($produkt_id)
		{
			
			$vp_data = @unserialize($this->controller->db->fetchOne("SELECT `variantenplus` FROM `".$this->controller->tbl_pr."` WHERE `id` = '".wpsg_q($produkt_id)."'"));
			if (!is_array($vp_data)) $vp_data = array();
			
			if ($this->controller->isOtherLang())
			{
				 
				foreach ($vp_data as $k => $v)
				{
					
					if (isset($vp_data[$k]['lang'][get_locale()]['name']) && $vp_data[$k]['lang'][get_locale()]['name'] != "")
					{
						$vp_data[$k]['name'] = $vp_data[$k]['lang'][get_locale()]['name'];
					}
					
					foreach ($v['vari'] as $k2 => $v2)
					{
						
						if (isset($vp_data[$k]['lang'][get_locale()]['vari'][$k2]['name']) && $vp_data[$k]['lang'][get_locale()]['vari'][$k2]['name'] != "")
						{
							$vp_data[$k]['vari'][$k2]['name'] = $vp_data[$k]['lang'][get_locale()]['vari'][$k2]['name'];
						}
						
					}
					
				}
				
			}
			
			return $vp_data;
			
		}

		public function mail_Besteller_Produktrow($produkt)
		{
			
			if ($produkt['v_id'] == -1 && isset($produkt['mod_vp_varkey']))
			{
				
				$this->data['produkt'] = $this->controller->db->fetchRow("SELECT * FROM `".$this->controller->tbl_pr."` WHERE `id` = '".wpsg_q($produkt['p_id'])."'");
				$this->data['vp_data'] = $this->loadVarianten($produkt['p_id']);
				
				$this->data['vp_set'] = array();
				
				$v_id = preg_replace("/^\d*\//", "", $produkt['mod_vp_varkey']);

				$var1 = explode(":", $v_id);
				foreach ($var1 as $v)
				{
					
					$var2 = explode("_", $v);
					
					$this->data['vp_set'][$var2[0]] = $var2[1];
					
				}
								
				$this->data['strVarianten'] = $this->loadVariantenString($produkt['p_id'], $produkt['mod_vp_varkey']);
				
				// Preise zurückrechnen wenn keine MwSt.
				if ($produkt['mwst'] <= 0)
				{
				
					// Hier wurde keine MwSt. angegbene, ich muss mir nun den originalen Satz holen und ihn herausrechnen
					$mwst_p = $this->controller->db->fetchOne("SELECT `value` FROM `".$this->controller->tbl_mw."` WHERE `id` = '".wpsg_q($this->data['produkt']['mwst'])."'");
					
					foreach ($this->data['vp_data'] as $k => $v)
					{
						
						foreach ($v['vari'] as $k2 => $v2)
						{
							
							$this->data['vp_data'][$k]['vari'][$k2]['preis'] = $v2['preis'] / (1 + ($mwst_p / 100));
							
						}
						
					}
					
				}
				
				include ABSPATH.$this->render_rel("mod_variantenplus/mailrow.phtml");
				
			} 
			
		}
		
		public function getVariantenName($vp_data, $var_id)
		{
			
			$name = $vp_data[$var_id]['name'];
			if (isset($_REQUEST['wpsg_lang']))
			{
				if ($vp_data[$var_id]['lang'][$_REQUEST['wpsg_lang']]['name'] != "")
				{
					$name = $vp_data[$var_id]['lang'][$_REQUEST['wpsg_lang']]['name'];
				}
			}
			
			return ((trim($name) == "")?"----":$name);
			
		} // public function getVariantenName($vp_data, $var_id)
		
		public function getVariName($vp_data, $var_id, $vari_id)
		{
			
			$name = $vp_data[$var_id]['vari'][$vari_id]['name'];						
			if (isset($_REQUEST['wpsg_lang']))
			{
				if ($vp_data[$var_id]['lang'][$_REQUEST['wpsg_lang']]['vari'][$vari_id]['name'] != "")
				{
					$name = $vp_data[$var_id]['lang'][$_REQUEST['wpsg_lang']]['vari'][$vari_id]['name'];
				}
			}
		
			return ((trim($name) == "")?"----":$name);
			
		} // public function getVariName($vp_data, $var_id, $vari_id)
		
		private function checkPics(&$arPics, $produkt_id)
		{
			
			foreach ($arPics as $k => $v)
			{
				
				//if (!file_exists(WP_CONTENT_DIR.'/uploads/produktbilder/'.$produkt_id."/".$v))
				if (!file_exists($this->controller->mods['mod_produktbilder']->getPicPath($produkt_id).'/'.$v))
				{
					unset($arPics[$k]);
				}
				
			}
			
			return $arPics;
			
		} // private function checkPics($arPics, $produkt_id)
		
	} // class mod_variantenplus extends mod_basic

?>